# all files / lighthouse-core/driver/gatherers/ service-worker.js

100% Statements 14/14
100% Branches 4/4
100% Functions 3/3
100% Lines 13/13

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65

    1×

    4×
    4×

    2×
    2×

    3×
    3×

    2×
    2×
    2×

    1×

    3×

    1×
     /**
     * @license
     * Copyright 2016 Google Inc. All rights reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    'use strict';

    const Gather = require('./gather');

    class ServiceWorker extends Gather {

      /**
       * @param {string} url
       * @return {string}
       */
      static getOrigin(url) {
        const parsedURL = require('url').parse(url);
        return `${parsedURL.protocol}//${parsedURL.hostname}`;
      }

      /**
       * @param {!Array<!ServiceWorkerVersion>} versions
       * @param {string} url
       * @return {(!ServiceWorkerVersion|undefined)}
       */
      static getActivatedServiceWorker(versions, url) {
        const origin = this.getOrigin(url);
        return versions.find(v => v.status === 'activated' && this.getOrigin(v.scriptURL) === origin);
      }

      beforePass(options) {
        const driver = options.driver;
        return driver
          .getServiceWorkerVersions()
          .then(data => {
            const version = ServiceWorker.getActivatedServiceWorker(data.versions, options.url);
            const debugString = version ? undefined : 'No active service worker found for this origin.';
            return {
              version,
              debugString
            };
          })
          .catch(err => {
            return {
              debugString: `Error in querying Service Worker status: ${err.message}`
            };
          }).then(artifact => {
            this.artifact = artifact;
          });
      }
    }

    module.exports = ServiceWorker;